// Generated by CoffeeScript 1.6.3
var exampleToHttpPayloadPair, expandUriTemplateWithParameters, inheritHeaders, inheritParameters, ut, walker;

inheritHeaders = require('./inherit-headers');

inheritParameters = require('./inherit-parameters');

expandUriTemplateWithParameters = require('./expand-uri-template-with-parameters');

exampleToHttpPayloadPair = require('./example-to-http-payload-pair');

ut = require('uri-template');

walker = function(app, resourceGroups) {
  var action, example, group, path, payload, resource, response, responses, sendResponse, _i, _j, _k, _l, _len, _len1, _len2, _len3, _len4, _m, _ref, _ref1, _ref2, _results;
  sendResponse = function(response) {
    var buildResponse;
    return buildResponse = function(req, res) {
      var header, value, _ref;
      _ref = response.headers;
      for (header in _ref) {
        value = _ref[header];
        res.setHeader(header, value['value']);
      }
      res.setHeader('Content-Length', Buffer.byteLength(response.body));
      return res.send(response.status, response.body);
    };
  };
  responses = [];
  for (_i = 0, _len = resourceGroups.length; _i < _len; _i++) {
    group = resourceGroups[_i];
    _ref = group['resources'];
    for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
      resource = _ref[_j];
      _ref1 = resource['actions'];
      for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
        action = _ref1[_k];
        action['headers'] = inheritHeaders(action['headers'], resource['headers']);
        action['parameters'] = inheritParameters(action['parameters'], resource['parameters']);
        if (resource['uriTemplate'] != null) {
          path = resource['uriTemplate'].split('{?')[0].replace(new RegExp("}", "g"), "").replace(new RegExp("{", "g"), ":");
          _ref2 = action['examples'];
          for (_l = 0, _len3 = _ref2.length; _l < _len3; _l++) {
            example = _ref2[_l];
            payload = exampleToHttpPayloadPair(example, action['headers']);
            response = payload['pair']['response'];
            responses.push({
              method: action.method,
              path: path,
              response: response
            });
          }
        }
      }
    }
  }
  responses.sort(function(a, b) {
    if (a.path > b.path) {
      return -1;
    }
    if (a.path < b.path) {
      return 1;
    }
    return 0;
  });
  _results = [];
  for (_m = 0, _len4 = responses.length; _m < _len4; _m++) {
    response = responses[_m];
    switch (response.method) {
      case 'GET':
        _results.push(app.get(response.path, sendResponse(response.response)));
        break;
      case 'POST':
        _results.push(app.post(response.path, sendResponse(response.response)));
        break;
      case 'PUT':
        _results.push(app.put(response.path, sendResponse(response.response)));
        break;
      case 'DELETE':
        _results.push(app["delete"](response.path, sendResponse(response.response)));
        break;
      case 'PATCH':
        _results.push(app.patch(response.path, sendResponse(response.response)));
        break;
      default:
        _results.push(void 0);
    }
  }
  return _results;
};

module.exports = walker;
